clear variables;
close all;
clc;

ksi=0.07; wn=2*pi;
tspan=[0,5];
num=100; xmax=20; vmax=50;

pend_ode=@(t,x)[x(2);-2*ksi*wn*x(2)-wn^2*sin(x(1))];

% a) regularny zestaw warunkw pocztkowych
% xInit=zeros(1,num); vInit=linspace(-vmax,vmax,num);

% b) losowy zestaw warunkw pocztkowych
xInit=xmax*(rand(1,num)-0.5); vInit=vmax*(rand(1,num)-0.5);

x1min=Inf; x1max=-Inf;
hold on;
for i=1:num
    [t,x]=ode45(pend_ode,tspan,[xInit(i);vInit(i)]);
    plot(x(:,1),x(:,2));
    x1min=min(x1min,min(x(:,1))); x1max=max(x1max,max(x(:,1)));
end
grid; xlabel('x1'); ylabel('x2');

xa=floor(x1min/pi); xb=ceil(x1max/pi); eq=xa:xb;
e1=eq(mod(eq,2)==0); e2=eq(mod(eq,2)==1);
p1=plot(pi*e1,zeros(1,numel(e1)),'.r','markersize',25); 
p2=plot(pi*e2,zeros(1,numel(e2)),'dr','markersize',10); hold off;
legend([p1,p2],'ogniska stabilne','sioda');