clear variables;
close all;
clc;

% wyznaczenie punktw rwnowagi (obliczenia symboliczne)
syms x1 x2;
x1p=x1^2+x2^2-4;
x2p=x1^2-x2^2+2*x1;
x=[];
x1sol=solve(x1p+x2p)';
for x1s=x1sol
    x2sol=unique(solve(subs(x1p,x1,x1s)));
    x=[x,[x1s*ones(1,numel(x2sol));x2sol']];
end
x

% modele zlinearyzowane w punktach rwnowagi
for i=1:size(x,2)
    A=[diff(x1p,x1),diff(x1p,x2);diff(x2p,x1),diff(x2p,x2)];
    A=double(subs(A,{'x1','x2'},{x(1,i),x(2,i)})); eigA=eig(A)
end

% trajektorie fazowe modelu nieliniowego (wykres typu 1)
x1min=min(double(x(1,:))); x1max=max(double(x(1,:))); x1span=x1max-x1min;
x2min=min(double(x(2,:))); x2max=max(double(x(2,:))); x2span=x2max-x2min;
marg=0.5;
x1a=x1min-marg*x1span; x1b=x1max+marg*x1span;
x2a=x2min-marg*x2span; x2b=x2max+marg*x2span;

nonlin_ode=@(t,x)[x(1)^2+x(2)^2-4;x(1)^2-x(2)^2+2*x(1)];

num=500; tspan=[0,0.4];
hold on;
for i=1:num
    x0=[x1a;x2a]+diag([x1b-x1a,x2b-x2a])*rand(2,1);
    [t,y]=ode45(nonlin_ode,tspan,x0); plot(y(:,1),y(:,2));
end
axis([x1a,x1b,x2a,x2b]); xlabel('x1'); ylabel('x2'); grid;
plot(double(x(1,:)),double(x(2,:)),'.r','markersize',25);
hold off;

% wykres typu 2
figure;
pts=20;
hold on;
[x1,x2]=meshgrid(linspace(x1a,x1b,pts),linspace(x2a,x2b,pts));
quiver(x1,x2,x1.^2+x2.^2-4,x1.^2-x2.^2+2*x1);
plot(double(x(1,:)),double(x(2,:)),'.r','markersize',25);
axis([x1a,x1b,x2a,x2b]); xlabel('x1'); ylabel('x2');
grid; hold off;